/*
   This replaces the lambda expression in MakeAdder_v2 with an
   anonymous inner class. Notice that there is still a nested function.
*/
import java.util.function.Function;

public class MakeAdder_v3
{
   public static void main(String args[])
   {
      Function<Integer,Integer> add4 = makeAdder(4);

      System.out.println( add4.apply(5) );
   }

   static Function<Integer,Integer> makeAdder(int x)
   {
     return new Function<Integer,Integer>(){public Integer apply(Integer y){return x + y;}};
   }
}
