/*
   This is a classic verion of makeAdder. It replaces the
   functional interface from MakeAdder_v3 with a local interface.
   Notice that there is still a nested function in line 18.
*/

public class MakeAdder_v4
{
   public static void main(String args[])
   {
      Adder add4 = makeAdder(4);

      System.out.println( add4.apply(5) );
   }

   static Adder makeAdder(int x)
   {
     return new Adder(){public int apply(int y){return x + y;}};
   }
}

interface Adder
{
   public int apply(int y);
}

/*
Use this URL to run this program in the Java Visualizer.

https://cscircles.cemc.uwaterloo.ca/java_visualize/#code=public+class+MakeAdder_v4%0A%7B%0A+++public+static+void+main(String+args%5B%5D)%0A+++%7B%0A++++++Adder+add4+%3D+makeAdder(4)%3B%0A%0A++++++System.out.println(+add4.apply(5)+)%3B%0A+++%7D%0A%0A+++static+Adder+makeAdder(int+x)%0A+++%7B%0A+++++return+new+Adder()%0A+++++%7B++public+int+apply(int+y)%0A++++++++%7B++return+x+%2B+y%3B%0A++++++++%7D%0A+++++%7D%3B%0A+++%7D%0A%7D%0A%0Ainterface+Adder%0A%7B%0A+++public+int+apply(int+y)%3B%0A%7D&mode=
*/