/*
   Here is the classic OOP way to define makeAdder. Notice that
   there is no nested function. Instead, there is an instance
   method in an object and it references an instance variable.
*/

public class MakeAdder_v5
{
   public static void main(String args[])
   {
      Adder add4 = new Adder(4);

      System.out.println( add4.apply(5) );
   }
}

class Adder
{
   int x;
   public Adder(int x){this.x = x;}
   public int apply(int y){return x + y;}
}
