/*
   NOTE: THIS DOES NOT COMPILE! This shows that Java
   closures are not the same as Scheme closures. Java's
   closures cannot implement the functionality of makeCounter.

   Remove the ++ in line 16 and this will compile and run,
   but it will no longer act like makeCounter.
*/
import java.util.function.IntSupplier;
import java.util.function.Function;

public class MakeCounter_v1
{
   public static void main(String args[])
   {
      Function<Integer, IntSupplier> makeCounter =  x -> (()-> ++x);

      IntSupplier countFrom4 = makeCounter.apply(4);

      System.out.println( countFrom4.getAsInt() );
      System.out.println( countFrom4.getAsInt() );
      System.out.println( countFrom4.getAsInt() );
   }
}
