/*
   This uses one less lambda expression
   than MakeAdder_v1.
*/
import java.util.function.Function;

public class MakeAdder_v2
{
   public static void main(String args[])
   {
      Function<Integer,Integer> add4 = makeAdder(4);

      System.out.println( add4.apply(5) );
   }

   static Function<Integer,Integer> makeAdder(int x)
   {
     return y -> x + y; // this lambda is nested in the makeAdder method
   }
}
